<template v-if="isFeatureEnabled">
    <el-dialog fullscreen v-model="isShowingVideo" center append-to-body close-on-click-modal class="inactivity-ads-dialog" width="100%">
        <div class="w-full h-full flex justify-center items-center">
            <video id="inactivity-ads" :src="inactivityAdsSetting?.ImagePath" playsinline autoplay muted loop style="width: 100%; max-height: 90%;"></video>
        </div>
    </el-dialog>
</template>

<script setup lang="ts">
import { store } from "@/store";
const DURATION_IN_MINUTES = 5;
const isShowingVideo = ref(false);
const idleTimer = ref<NodeJS.Timeout>();
const inactivityAdsSetting = computed(() => store.state.companyThemePropertiesFromApi.ThemeProperties.find(property => property.HtmlId === 'inactivity_ads'));
const isFeatureEnabled = computed(() =>inactivityAdsSetting.value && !inactivityAdsSetting.value.IsHidden);

// reset the idle timer
function resetIdleTimer() {
    isShowingVideo.value = false;
    if (!isFeatureEnabled.value) return;
    // !!!IMPORTANT!!!
    clearTimeout(idleTimer.value);
    idleTimer.value = setTimeout(function () {
        isShowingVideo.value = true;
    }, DURATION_IN_MINUTES * 60 * 1000);
}

onMounted(() => {
    // event listeners for mousemove, keydown, scroll and touch events
    document.addEventListener("mousemove", resetIdleTimer);
    document.addEventListener("keydown", resetIdleTimer);
    document.addEventListener("scroll", resetIdleTimer);
    document.addEventListener("touchmove", resetIdleTimer);

    // initial setup when the page loads
    resetIdleTimer();
});

onBeforeUnmount(() => {
    // remove event listeners
    document.removeEventListener("mousemove", resetIdleTimer);
    document.removeEventListener("keydown", resetIdleTimer);
    document.removeEventListener("scroll", resetIdleTimer);
    document.removeEventListener("touchmove", resetIdleTimer);

    // remove timeout
    clearTimeout(idleTimer.value);
})
</script>

<style>
.inactivity-ads-dialog .el-dialog__body {
    max-width: 100vw;
    height: calc(100vh - 60px);
}
</style>